---
    - name: Install Peerplays Faucet
      hosts: ubuntu
      become: true

      vars:
        instance_user: 'ubuntu'
        project_dir: '/usr/local/lib/faucet'
        nobroadcast: 'False'
        witness_url: 'ws:\/\/127.0.0.1:8090'
        registrar: "nathan"
        default_referrer: 'nathan'
        wif: '5KQwrPbwdL6PhXujxW37FSSQZ1JiwsST4cqQzDeyXtP79zkvFD3'
        core_asset: 'TEST'
        
      tasks:
        - name: Install dependencies
          become: yes
          apt:
            name: "{{ packages }}"  
          vars:
            packages:    
            - libffi-dev
            - libssl-dev
            - python-dev
            - python3-dev
            - python3-pip
            - python3-venv
            - redis-server
            state: latest 

        - name: Clone git repoistory
          git:
            repo: 'https://gitlab.com/PBSA/PeerplaysIO/tools-libs/faucet.git'
            dest: "{{ project_dir }}"
            version: develop
            accept_hostkey: yes
      
        - name: Creates python virtual env 
          pip: 
            requirements: "{{ project_dir }}/requirements.txt"
            virtualenv: "{{ project_dir }}/env"
            virtualenv_command: 'python3 -m venv'

        - name: Change ownership to instance user
          file:
            path: "{{ project_dir }}"
            owner: "{{ instance_user }}"
            group: "{{ instance_user }}"
            state: directory
            recurse: yes
        
        - name: Configure faucet
          become_user: "{{ instance_user }}"
          shell: |
            cd "{{ project_dir }}"
            cp config-example.yml config.yml
            sed -i 's/.*nobroadcast.*/nobroadcast: \"{{ nobroadcast }}\"/' ./config.yml
            sed -i 's/.*registrar.*/registrar: \"{{ registrar }}\"/' ./config.yml
            sed -i 's/.*itness_url.*/witness_url: \"{{ witness_url }}\"/' ./config.yml
            sed -i 's/.*default_referrer.*/default_referrer: \"{{ default_referrer }}\"/' ./config.yml
            sed -i 's/.*wif.*/wif: \"{{ wif }}\"/' ./config.yml
            sed -i 's/.*core_asset.*/core_asset: \"{{ core_asset }}\"/' ./config.yml
